//
// Implementazione della Classe Queue. Prima versione.
//


#include <iostream.h>
#include "Queue1.H"


// Costruttore per il tipo di dato Coda.
Queue::Queue(int size)
{
  if (size < 1) {
    cerr << "Errore: la Coda deve avere almeno un elemento!" << endl;
    exit(-1);
  }

  data = new mytype[size];	// Crea un array di lunghezza assegnata
  
  len = 0;		// La Coda e` vuota
  head = 0;
  maxlen = size;
}


// Distruttore per il tipo di dato Coda.
Queue::~Queue()
{
  delete[] data;
}


// Restituisce l'elemento in testa alla Coda.
mytype Queue::Read()
{
  if (IsEmpty()) {
    cerr << "Errore: la Coda e` vuota!" << endl;
    exit(-2);
  }

  return(data[head]);
}


// Rimuove un elemento dalla testa della Coda.
mytype Queue::Dequeue()
{
  int t = head;

  if (IsEmpty()) {
    cerr << "Errore: la Coda e` vuota!" << endl;
    exit(-2);
  }
  else {
    head = (head + 1) % maxlen;		// Sposto la testa avanti di un posto.
					// Se arrivo in fondo ricomincio da 0.
    len--;
  }

  return(data[t]);		// Restituisco la vecchia testa della Coda.
}


// Inserisce l'elemento d in fondo alla Coda.
void Queue::Enqueue(const mytype &d)
{
  if (len != maxlen) {
    data[(head + len) % maxlen] = d;
    len++;
  }  else {
    cerr << "Errore: la Coda e` piena!" << endl;
    exit(-2);
  }
}
